#!/usr/bin/python
'''
 Copyleft 2004 Brett Hartshorn bhartsho@yahoo.com http://opart.org 
 Program to load the egg.xml database and boot it.
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version. http://gnu.org 

 Useage:
	(run as root)
	./chicken.py [flags]

 If you need Python for Windows...
 http://python.org/ftp/python/2.3.4/Python-2.3.4.exe 

'''

def _installer(url):
	import os, sys, urllib
	if sys.platform == 'win32':
		print 'Installing...', url
		tmp = 'c:\\temp.exe'
		f = urllib.urlopen(url)
		data = f.read()
		f.close()
		f = open(tmp, 'wb')
		f.write(data)
		f.close()
		os.system(tmp)
		os.remove(tmp)
	else:
		raise 'sorry, no installer for platform'

# check dependices.
try: import xml.xpath
except ImportError: _installer('http://voxel.dl.sourceforge.net/sourceforge/pyxml/PyXML-0.8.4.win32-py2.3.exe')


import xml.dom, sys, os
from xml.dom import minidom


print 'Hello World...'
print 'My Name is', sys.argv[0]

# if no egg, get latest version
if not os.path.exists('egg.xml'):
	import urllib
	url = 'http://opart.org/egg.xml'
	print 'Downloading Fresh Egg...'
	print url
	print 'please wait...'
	f = urllib.urlopen(url)
	data = f.read()
	f.close()
	f = open('egg.xml', 'wb')
	f.write(data)
	f.close()

# load the egg into memory, parse it, and get the bootstrap program from it.
doc = minidom.parse('egg.xml')
e = xml.xpath.Evaluate('/egg/projects/bootstrap/python/text()', doc)
txt = e[0].data

# clean up the chicken's mess
del e
del doc
del _installer

# must unescape the text
txt = txt.replace('&' + 'lt;', '<')
txt = txt.replace('&' + 'gt;', '>')
txt = txt.replace('&' + 'amp;', '&')

print 'Now booting the Egg...'
exec txt
# end of chicken
